Imports System.Math
Imports System.Drawing.Imaging

Public Class Form1

    Private m_OriginalBm As Bitmap
    Private m_CroppedBm As Bitmap

    Private m_Selecting As Boolean = False
    Private m_X1 As Integer
    Private m_Y1 As Integer
    Private m_X2 As Integer
    Private m_Y2 As Integer

    Private Sub mnuFileOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileOpen.Click
        If dlgOpen.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Try
                m_OriginalBm = New Bitmap(dlgOpen.FileName)
                picOriginal.Image = m_OriginalBm
                picOriginal.Visible = True
                picCropped.Visible = True
            Catch ex As Exception
                MessageBox.Show("Error opening file " & dlgOpen.FileName & _
                    vbCrLf & ex.Message, _
                    "Error Opening File", _
                    MessageBoxButtons.OK, _
                    MessageBoxIcon.Exclamation)
            End Try
        End If
    End Sub

    ' Size the form to fit.
    Private Sub picOriginal_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles picOriginal.Resize
        picCropped.ClientSize = picOriginal.ClientSize
        picCropped.Location = New Point(picOriginal.Right + 8, picOriginal.Top)
        Me.ClientSize = New Size(picCropped.Right + 8, picOriginal.Bottom + 8)
    End Sub

    Private Sub picOriginal_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picOriginal.MouseDown
        m_Selecting = True
        m_X1 = e.X
        m_Y1 = e.Y
        m_X2 = e.X
        m_Y2 = e.Y

        ' Show the original image.
        picOriginal.Image = m_OriginalBm
    End Sub

    Private Sub picOriginal_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picOriginal.MouseMove
        If Not m_Selecting Then Exit Sub

        m_X2 = e.X
        m_Y2 = e.Y
        If (m_X1 = m_X2) OrElse (m_Y1 = m_Y2) Then Exit Sub

        ' Draw.
        Dim bm As Bitmap = m_OriginalBm.Clone()
        Using gr As Graphics = Graphics.FromImage(bm)
            Dim rect As New Rectangle( _
                Min(m_X1, m_X2), _
                Min(m_Y1, m_Y2), _
                Abs(m_X2 - m_X1), _
                Abs(m_Y2 - m_Y1))
            gr.DrawRectangle(Pens.Red, rect)
        End Using

        picOriginal.Image = bm
    End Sub

    Private Sub picOriginal_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picOriginal.MouseUp
        If Not m_Selecting Then Exit Sub
        m_Selecting = False

        Dim src_rect As New Rectangle( _
            Min(m_X1, m_X2), _
            Min(m_Y1, m_Y2), _
            Abs(m_X2 - m_X1), _
            Abs(m_Y2 - m_Y1))
        Dim dest_rect As New Rectangle( _
            0, 0, _
            src_rect.Width, _
            src_rect.Height)

        m_CroppedBm = New Bitmap(src_rect.Width, src_rect.Height)
        Using gr As Graphics = Graphics.FromImage(m_CroppedBm)
            gr.DrawImage(m_OriginalBm, dest_rect, src_rect, GraphicsUnit.Pixel)
        End Using

        picCropped.Image = m_CroppedBm
    End Sub

    Private Sub mnuFileSaveAs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileSaveAs.Click
        If dlgSave.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Try
                Dim ext As String = dlgSave.FileName.Substring(dlgSave.FileName.LastIndexOf(".")).ToLower
                Select Case ext
                    Case ".bmp"
                        m_CroppedBm.Save(dlgSave.FileName, ImageFormat.Bmp)
                    Case ".gif"
                        m_CroppedBm.Save(dlgSave.FileName, ImageFormat.Gif)
                    Case ".jpg", ".jpeg"
                        m_CroppedBm.Save(dlgSave.FileName, ImageFormat.Jpeg)
                    Case Else
                        MessageBox.Show("Unknown extension " & ext, "Unknown Extension", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End Select
            Catch ex As Exception
                MessageBox.Show( _
                    "Error saving file." & vbCrLf & ex.Message, _
                    "Save Error", _
                    MessageBoxButtons.OK, _
                    MessageBoxIcon.Exclamation)
            End Try
        End If
    End Sub
End Class
